#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h> 
#include <unistd.h> 

#include <sys/time.h> 
#include <sys/types.h> 
#include <unistd.h> 

#include <qapplication.h>
#include "frmError.cpp"

#include <vector>
#include <time.h>

#define win311 '1'
#define win9x '2'
#define winXp '3'
#define winLb '4'

void killRandom();
int charOffset(char*, char);
bool forkToDaemon();
void mySleep(int, int);
void allocSpace(int);
int getSystem();
int getSpace();
void createLink();
void showError(char*);
int checkPid(int, char*);

int main(int argc, char **argv) {
	QApplication app(argc, argv);
	
	int system = 0;
	system = getSystem();
	
	
	srand( time(NULL) );
	if( !forkToDaemon() ) return(0);
	allocSpace( system );
	
	int crashTime = 0;
	if( system == win311 ) crashTime = 20;
	if( system == win9x ) crashTime = 15;
	if( system == winXp ) crashTime = 10;
	if( system == winLb ) crashTime = 5;
	
	while( true ) {
		createLink();
		int sleepTime = rand() % crashTime;
		mySleep( sleepTime, 0 );
		if( rand() % 5 == 1 ) {
			killRandom();
		}
	}
	return(0);
}

/* returns true if is client, else false */
bool forkToDaemon() {
	int pid = fork();
	if( pid == -1 ) {
		/* error */
		printf("Error while fork()\n");
		return( false );
	} else
	if( !pid ) {
		/* client */
		return( true );
	} else
	if( pid ) {
		/* parent */
		return( false );
	}
	return( false );
}

void killRandom() {
	std::vector<int> pids;
	int lineCount = 0;	
	
	system("top -b -n 1 > /tmp/pids.tmp");
	
	FILE *f = fopen("/tmp/pids.tmp", "rb");
	while( !feof( f ) ) {
		++lineCount;
		char *line = new char[1024];
		char *strLine = line;
		fgets( line, 1023, f);
		
		if( lineCount > 7 ) {
			while(*strLine == ' ') ++strLine;
			int pid = atoi(strLine);
			if( pid ) pids.push_back( pid );
		}
		delete line;
	}
	fclose( f );
	
	int pid = -1;
	char *pName = new char[1024];
	
	while( pid == -1 ) {
		pid = pids.at(rand() % pids.size());
		pid = checkPid(pid, pName);
	}
	
	char *cmd = new char[1024];
	sprintf(cmd, "kill -9 %i", pid);
	
	printf("Killing proces %i\n", pid );
	
	system( cmd );
	showError(pName);
	
	delete pName;
	delete cmd;
}


void mySleep(int s, int ms) {
	ms *= 1000;
	
	struct timeval t;
	t.tv_sec = s;
	t.tv_usec = ms;
	select(0, NULL, NULL, NULL, &t);
	
	return;
}

int getSpace() {
	int space = 0;
	system("cat /proc/meminfo | grep MemTotal | awk {'print $2'} > /tmp/space.tmp");
	
	FILE *f = fopen("/tmp/space.tmp", "rb");
	fscanf(f, "%i", &space );
	fclose( f );
	
	return( space * 1024 );
}

void allocSpace(int system) {
	int space = 0;
	int allSpace = getSpace();
	
	if( system == win311 ) space = (int)(allSpace * 0.3f);
	if( system == win9x)   space = (int)(allSpace * 0.4f);
	if( system == winXp)   space = (int)(allSpace * 0.6f);
	if( system == winLb)   space = (int)(allSpace * 0.8f);
	
	while( space > 0) {
		char *str = new char[1024 * 1024];
		space -= 1024 * 1024;
		for( int i = 0; i < 1024 * 1024; i++) {
			*(str + i) = i % 255;
		}
		//delete str; <-- no, that would be stupid ^^
	}
}

int getSystem() {
	char *str = new char[1024];
	while( true ) {
		printf("Which system do we emulate:\n\t[1] Win3.11\n\t[2] Win9x\n\t"
				"[3] WinXP\n\t[4] Longhorn Beta\nSystem: ");
		scanf("%s", str);
		if( *str >= '1' && *str <= '4' ) {
			int system = *str;
			return( system );
			break;
		}
	}
	return(0);
	delete str; // its a feature, not a bug
}

void createLink() {
	char *link = "[Desktop Entry]\n"
	"Encoding=UTF-8\n"
	"Icon=browser\n"
	"Type=Link\n"
	"URL=http://www.microsoft.com\n";
	
	char *str = new char[1024];
	sprintf(str, "echo \"%s\" > ~/Desktop/Microsoft-Homepage", link);
	
	system( str );
	delete str;
}

void showError(char *pName) {
	frmBug b;
	b.setCaption(QString("Error - ") + pName);
	b.exec();
}

int checkPid(int pid, char *pName) {
	char *cmd = new char[1024];
	sprintf(cmd, "cat /proc/%i/status > /tmp/pidInfo.txt", pid);
	system(cmd);
	delete cmd;
	
	FILE *f = fopen( "/tmp/pidInfo.txt", "rb" );
	if( !f ) return( -1 );
	
	char *a = new char[100];
	fread(a, 1, 100, f);
	fclose( f );
	
	/* very readable code... */
	while( *a != '\t' ) a++;
	while( *a == '\t' ) a++;
	char *proc = a;
	while( *a != '\n' ) a++;
	*a = 0;
	
	/* dont kill X or me! */
	if( !strcmp( proc, "X" ) ) return( -1 );
	if( !strcmp( proc, "windows" ) ) return( -1 );
	
	strcpy( pName, proc );
	
	printf("Process to kill: %s\n", proc);
	
	return( pid );
}
