/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you want to add, delete, or rename functions or slots, use
** Qt Designer to update this file, preserving your code.
**
** You should not define a constructor or destructor in this file.
** Instead, write your code in functions called init() and destroy().
** These will automatically be called by the form's constructor and
** destructor.
*****************************************************************************/
#include <qtimer.h>
#include <qmessagebox.h>

QTimer timer;

void frmBug::pushButton1_clicked()
{
    close(0);
}


void frmBug::pushButton1_2_clicked()
{
    connect( &timer, SIGNAL( timeout() ), this, SLOT( tTimeout() ));
    errBar->show();
    pushButton1->setEnabled( false );
    pushButton1_2->setEnabled( false );
    timer.start(500);
}


void frmBug::tTimeout()
{
    errBar->setProgress( errBar->progress() + 10);
    if( errBar->progress() > 60 ) {
		timer.stop();
		QMessageBox mb("Error", "Error while sending the error message to Microsoft.", QMessageBox::Critical, QMessageBox::Cancel,
			QMessageBox::NoButton, QMessageBox::NoButton);
		QPixmap p;
		
		p.load("cancel.png");
		mb.setIconPixmap( p );
		mb.exec();
		close(0);
    }
}


void frmBug::init()
{
    errBar->hide();
}

#include "frmError.moc"
